<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 03/22/2004 *
 * ================                             Last change: 12/13/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-extentions.php                              *
 * -------------------------------------------------------------------- *
 * Short description : Extension management                             *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Erweiterungen-Management                         *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((ereg(basename(__FILE__), $_SERVER['PHP_SELF'])) || (!IS_ADMIN())) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Add description as navigation point
ADD_DESCR("admin", basename(__FILE__));

global $cacheInstance, $cacheArray, $cacheMode;

// Normally we want the overview of all registered extensions
$do = "overview";
$SEL = "0";
if (!empty($_POST['sel'])) $SEL = SELECTION_COUNT($_POST['sel']);

if (!empty($_GET['reg_ext'])) {
	// We are about to register a new extension
	$do = "register"; $id = $_GET['reg_ext'];
	// The ID comes from task management and it is - of course - *not* the extension's name!
} elseif ((isset($_POST['change'])) && ($SEL > 0) && (!IS_DEMO())) {
	// De-/activate extensions
	foreach ($_POST['sel'] as $id=>$active) {
		// Shall we keep the extension always active?
		if ((isset($cacheArray['active_extensions'][GET_EXT_NAME($id)])) && ($cacheArray['active_extensions'][GET_EXT_NAME($id)] == "Y") && ($active == "N")) {
			// Keep this extension active!
		} else {
			// De/activate extension
			$ACT = "N"; $EXT_LOAD_MODE = "deactivate";
			if ($active == "N") { $ACT = "Y"; $EXT_LOAD_MODE = "activate"; }
			$result = SQL_QUERY_ESC("UPDATE "._MYSQL_PREFIX."_extensions SET ext_active='".$ACT."' WHERE id=%d AND ext_active='%s' LIMIT 1",
			 array(bigintval($id), $active), __FILE__, __LINE__);

			// Run embeded SQL commands
			EXTENSION_RUN_SQLS($id, $EXT_LOAD_MODE);
		}
	}
} elseif (((isset($_POST['edit'])) || (isset($_POST['modify']))) && ($SEL > 0) && (!IS_DEMO())) {
	// Change settings like CSS file load
	if (isset($_POST['modify'])) {
		// Change entries
		$cacheInstance_UPDATE = "0";
		foreach ($_POST['sel'] as $id=>$sel) {
			// Secure ID
			$id = bigintval($id);

			// Change this extension?
			if ($sel == 1) {
				// Update extension's record
				$active = $_POST['active'][$id];
				if (GET_EXT_VERSION("sql_patches") >= "0.0.6") 	{
					// Update also CSS column when extensions sql_patches is newer or exact v0.0.6
					$result = SQL_QUERY_ESC("UPDATE "._MYSQL_PREFIX."_extensions SET ext_has_css='%s', ext_active='%s' WHERE id=%d LIMIT 1",
					 array($_POST['css'][$id], $active, $id), __FILE__, __LINE__);
				} else {
					// When extension is older than v0.0.6 there is no column for the CSS information
					$result = SQL_QUERY_ESC("UPDATE "._MYSQL_PREFIX."_extensions SET ext_active='%s' WHERE id=%d LIMIT 1",
					 array($active, $id), __FILE__, __LINE__);
				}

				// Run SQLs on activation / deactivation
				switch ($active) {
					case 'Y': $EXT_LOAD_MODE = "activate";   break;
					case 'N': $EXT_LOAD_MODE = "deactivate"; break;
				}

				// Run embeded SQL commands
				EXTENSION_RUN_SQLS($id, $EXT_LOAD_MODE);
			}
		}

		// Extensions changed
		OUTPUT_HTML("<P align=\"center\">");
		LOAD_TEMPLATE("admin_settings_saved", false, ADMIN_EXT_CHANGED);
		OUTPUT_HTML("</P>");
	} else {
		// Edit selected entries
		$SW = "2"; $OUT = "";
		foreach ($_POST['sel'] as $id=>$sel) {
			// Edit this extension?
			if (($sel == "Y") || ($sel == "N")) {
				// Load required data
				if (GET_EXT_VERSION("sql_patches") >= "0.0.6") {
					$result = SQL_QUERY_ESC("SELECT ext_name, ext_has_css, ext_active FROM "._MYSQL_PREFIX."_extensions WHERE id=%d LIMIT 1",
					 array(bigintval($id)), __FILE__, __LINE__);
					list($name, $css, $active) = SQL_FETCHROW($result);
					SQL_FREERESULT($result);
				} else {
					$result = SQL_QUERY_ESC("SELECT ext_name, ext_active FROM "._MYSQL_PREFIX."_extensions WHERE id=%d LIMIT 1",
					 array(bigintval($id)), __FILE__, __LINE__);
					list($name, $active) = SQL_FETCHROW($result);
					SQL_FREERESULT($result);
					$css = "X";
				}

				// Output row
				$CSS = "---";
				if (GET_EXT_VERSION("sql_patches") >= "0.0.6") $CSS = ADD_SELECTION("yn", $css, "css", $id);

				// Prepare data for the row template
				$content = array(
					'sw'     => $SW,
					'id'     => $id,
					'name'   => $name,
					'active' => ADD_SELECTION("yn", $active, "active", $id),
					'css'    => $CSS,
				);

				// Load row template and switch color
				$OUT .= LOAD_TEMPLATE("admin_extensions_edit_row", true, $content);
				$SW = 3 - $SW;
			}
		} // END - foreach
		define('__EXTENSIONS_ROWS', $OUT);

		// Load template
		LOAD_TEMPLATE("admin_extensions_edit");
		$do = "edit";
	}
} elseif ((isset($_POST['delete'])) && ($SEL > 0) && (!IS_DEMO())) {
	// List extensions and when verbose is enabled SQL statements which will be executed
	$SW = 2; $OUT = "";
	foreach ($_POST['sel'] as $id=>$sel) {
		// Init variables
		$VERBOSE_OUT = ""; $SQLs = array();

		// Secure id number
		$id = bigintval($id);

		// Get extension name
		$ext_name = GET_EXT_NAME($id);
		$ext_ver = GET_EXT_VERSION($ext_name);

		// Free the result
		SQL_FREERESULT($result);

		if ($_CONFIG['verbose_sql']) {
			// Load SQL commands in remove mode
			$EXT_LOAD_MODE = "remove";
			$file = sprintf("%sinc/extensions/ext-%s.php", PATH, $ext_name);
			include($file);

			// Generate extra table with loaded SQL commands
			$VERBOSE_OUT = EXTENSION_VERBOSE_TABLE($SQLs);
		} // END - if

		// Prepare data for the row template
		$content = array(
			'sw'       => $SW,
			'id'       => $id,
			'ext_name' => $ext_name,
			'ext_ver'  => $ext_ver,
			'verbose'  => $VERBOSE_OUT
		);

		// Load row template and switch color
		$OUT .= LOAD_TEMPLATE("admin_extensions_delete_row", true, $content);
		$SW = 3 - $SW;
	} // END - foreach
	define('__EXTENSIONS_ROWS', $OUT);

	// Load template
	LOAD_TEMPLATE("admin_extensions_delete");
	$do = "delete";
} elseif ((isset($_POST['remove'])) && ($SEL > 0) && (!IS_DEMO())) {
	// Remove extensions from DB (you have to delete all files manually!)
	$cacheInstance_UPDATE = "0";
	foreach ($_POST['sel'] as $id=>$active) {
		// Secure ID number
		$id = bigintval($id);

		// Is this extension selected?
		if ($active == 1) {
			// Run embeded SQL commands
			EXTENSION_RUN_SQLS($id, "remove");
		} // END - if
	} // END - foreach
} elseif (!empty($_GET['do']) && (!IS_DEMO())) {
	// Other things to do
	$do = SQL_ESCAPE(strip_tags($_GET['do']));
} elseif (!empty($_GET['do'])) {
	// Demo mode active!
	$do = "demo";
}

// Shall we display active/inactive extensions?
$where = "";
if (!empty($_GET['active'])) {
	$where = sprintf("WHERE ext_active = '%s'", SQL_ESCAPE(strip_tags($_GET['active'])));
} // END - if

// Case selection
switch ($do) {
case "overview": // List all registered extensions
	if (GET_EXT_VERSION("sql_patches") >= "0.0.6") {
		// Load extension data with CSS informations
		$result = SQL_QUERY("SELECT id, ext_name, ext_lang_file, ext_active, ext_has_css, ext_version
		FROM "._MYSQL_PREFIX."_extensions
		".$where."
		ORDER BY ext_name", __FILE__, __LINE__);
	} else {
		// Load extension data without CSS informations
		$result = SQL_QUERY("SELECT id, ext_name, ext_lang_file, ext_active, id, ext_version
		FROM "._MYSQL_PREFIX."_extensions
		".$where."
		ORDER BY ext_name", __FILE__, __LINE__);
	}

	// Are there some entries?
	if (SQL_NUMROWS($result) > 0) {
		// Extensions are registered
		$SW = 2; $OUT = "";
		while (list($id, $name, $lang, $active, $css, $ver) = SQL_FETCHROW($result)) {
			$CSS = "---";
			if (GET_EXT_VERSION("sql_patches") >= "0.0.6") $CSS = TRANSLATE_YESNO($css);

			// Prepare data for the row template
			$content = array(
				'sw'      => $SW,
				'id'      => $id,
				'name'    => $name,
				'active'  => TRANSLATE_YESNO($active),
				'act_val' => $active,
				'lang'    => $lang,
				'css'     => $CSS,
				'ver'     => $ver,
			);

			// Load row template and switch color
			$OUT .= LOAD_TEMPLATE("admin_extensions_row", true, $content);
			$SW = 3 - $SW;
		}

		// Free memory
		SQL_FREERESULT($result);

		// Remember rows in constant for the template
		define('__EXT_ROWS', $OUT);

		// Load template
		LOAD_TEMPLATE("admin_extensions");
	} else {
		// No extensions are registered
		LOAD_TEMPLATE("admin_settings_saved", false, ADMIN_NO_EXTENSION_REGISTERED."</FONT>");
	}
	// Link for checking for new or updated extensions
	OUTPUT_HTML("<br /><A href=\"".URL."/modules.php?module=admin&amp;what=extensions&amp;do=search\">".ADMIN_SEARCH_NEW_EXTENSIONS."</A>");
	break;

case "register": // Register new extension
	$result = SQL_QUERY_ESC("SELECT id FROM "._MYSQL_PREFIX."_task_system WHERE assigned_admin='%s' AND task_type='EXTENSION' LIMIT 1",
	 array(bigintval(GET_ADMIN_ID(get_session('admin_login')))), __FILE__, __LINE__);
	$task_found = SQL_NUMROWS($result);

	// Free result
	SQL_FREERESULT($result);

	// Is the ID number valid and the task was found?
	if (($id > 0) && ($task_found == 1)) {
		// ID is valid so begin with registration, we first want to it's real name from task management (subject column)
		$result = SQL_QUERY_ESC("SELECT subject FROM "._MYSQL_PREFIX."_task_system WHERE id=%d LIMIT 1",
		 array(bigintval($id)), __FILE__, __LINE__);
		list($subj) = SQL_FETCHROW($result);
		SQL_FREERESULT($result);

		// Disable cache update by default
		$cacheInstance_UPDATE = "0";
		if (!empty($subj)) {
			// Extract extension's name from subject...
			$ext_name = trim(substr($subj, 1, strpos($subj, ":") - 1));

			// ... so we can finally register and load it in registration mode
			$status = EXTENSION_REGISTER($ext_name, $id);
			if ($status == true) {
				// Extension was found and successfully registered
				LOAD_TEMPLATE("admin_settings_saved", false, ADMIN_EXTENSION_REGISTERED);

				// Do we need to update cache file?
				if ((EXT_IS_ACTIVE("cache")) && ($cacheMode != "no")) {
					// Remove cache file (will be auto-created again!)
					if ($cacheInstance->cache_file("config"    , true)) $cacheInstance->cache_destroy();
					if ($cacheInstance->cache_file("extensions", true)) $cacheInstance->cache_destroy();
					if ($cacheInstance->cache_file("mod_reg"   , true)) $cacheInstance->cache_destroy();
				}
			} else {
				// Motify the admin that we have a problem here...
				LOAD_TEMPLATE("admin_settings_saved", false, ADMIN_REG_FAILED_404);
			}
		} else {
			// Extension was not found in task management
			LOAD_TEMPLATE("admin_settings_saved", false, ADMIN_REG_FAILED_ID_404);
		}
	} elseif ($task_found == "0") {
		// No longer assigned or old task
		LOAD_TEMPLATE("admin_settings_saved", false, ADMIN_REG_FAILED_ASSIGED);
	} else {
		// ID is invalid
		LOAD_TEMPLATE("admin_settings_saved", false, ADMIN_REG_FAILED_INVALID);
	}
	break;

case "search": // Search for new extensions on our server
	// Get response from our server
	$response = MXCHANGE_OPEN("extensions.php");

	// Are extensions found?
	if (($response[sizeof($response) - 1] == "[EOF]") && ($response[0] != "[EOF]"))
	{
		// Ok, mark found and create the array
		$EXT_SEARCH = array(
			'fname'  => array(), // File names
			'fsize'  => array(), // File size
			'fctime' => array(), // File creation timestamp
			'infos'  => array(), // File informations (maybe loaded!)
			'ver'    => array(), // Version number
			'cver'   => array(), // Current version number
		);

		// Get count of extensions for validation
		$count = trim($response[sizeof($response) - 2]);
		foreach ($response as $id=>$value)
		{
			$value = str_replace("\n", "", $value); $ver = "";
			// Leave loop when data is invalid or EOF?
			if ((substr($value, 0, 4) == "ext-") && (substr($value, -4) == ".zip"))
			{
				$name = substr($value, 4, -4);
				$file = sprintf("%sinc/extensions/ext-%s.php", PATH, $name);
				$ver = trim(substr($response[$id + 3], 4));

				// Load current extension's version
				$cver = GET_EXT_VERSION($name);
				if (empty($cver)) $cver = "-.-";

				// Is the extension already installed or not?
				if (!file_exists($file) || ($ver != $cver))
				{
					// No, it isn't. So let's add this one!
					$EXT_SEARCH['fname'][]  = $name;
					$EXT_SEARCH['fsize'][]  = $response[$id + 1];
					$EXT_SEARCH['fctime'][] = $response[$id + 2];
					$EXT_SEARCH['ver'][]    = $ver;
					$EXT_SEARCH['cver'][]   = $cver;

					$LANG_DUMMY = explode("[nl]", $response[$id + 4]);
					$LANG = array();
					$INFO = ADMIN_EXT_NO_INFO_FOUND;

					// Trim every data line
					foreach ($LANG_DUMMY as $k=>$v)
					{
						$v = trim($v);
						if (substr($v, 3) == "") $v = "---";
						$LANG_DUMMY[$k] = $v;
						if ($v == "xx:xx") break;
						$LANG[] = $v;
					}

					// If language is found stop searching on matching line
					foreach($LANG as $search)
					{
						if (substr($search, 0, 3) == (GET_LANGUAGE().":")) { $INFO = substr($search, 3); break; }
					}

					// Add informations to array
					$EXT_SEARCH['infos'][] = $INFO;
				}
			}
		}

		// Ok, extensions are on our server but maybe you have already installed them?
		if (sizeof($EXT_SEARCH['fname']) > 0)
		{
			// Sort array (I missed ver and cver here)
			array_pk_sort($EXT_SEARCH, array("cver", "fname"), 0, 1);

			// Extensions where found which are not downloaded and installed
			$SW = 2; $OUT = ""; $TSIZE = 0;
			foreach ($EXT_SEARCH['fname'] as $id=>$name)
			{
				// Generate download link
				$LINK = SERVER_URL."/extensions/ext-".$name.".zip";

				// Prepare data for the row template
				$content = array(
					'sw'      => $SW,
					'id'      => ($id + 1),
					'name'    => $name,
					'new_ver' => $EXT_SEARCH['ver'][$id],
					'old_ver' => $EXT_SEARCH['cver'][$id],
					'link'    => $LINK,
					'last'    => MAKE_DATETIME($EXT_SEARCH['fctime'][$id], "2"),
					'size'    => TRANSLATE_COMMA(round($EXT_SEARCH['fsize'][$id] / 1.024) / 1000),
					'info'    => $EXT_SEARCH['infos'][$id],
				);

				// Load row template add current size to total size and switch color
				$OUT .= LOAD_TEMPLATE("admin_list_extensions_row", true, $content);
				$TSIZE += $EXT_SEARCH['fsize'][$id];
				$SW = 3 - $SW;
			}
			define('__EXTENSIONS_ROWS', $OUT);
			define('__TKBYTES_VALUE', TRANSLATE_COMMA(round($TSIZE / 1.024) / 1000));
			define('__TEXT_VALUE', sizeof($EXT_SEARCH['fname']));

			// Load template
			LOAD_TEMPLATE("admin_list_extensions");
		}
		 else
		{
			// All extensions are downloaded and installed
			LOAD_TEMPLATE("admin_extensions_installed", false, $count);
		}
	}
	 else
	{
		// No extensions where found
		LOAD_TEMPLATE("admin_extensions_404");
	}
	break;

case "demo":
	LOAD_TEMPLATE("admin_settings_saved", false, SETTINGS_NOT_SAVED);
	break;
}
//
?>
